#include<bits/stdc++.h>
using namespace std;

const int nmax=5e2+42,MX=10000+42;

int x_move[4]={0,0,1,-1};
int y_move[4]={1,-1,0,0};

int n,m;

int inp[nmax][nmax];

int dist[16][nmax][nmax];

int DIGIT;

int cost(int x,int y)
{
    return abs(inp[x][y]-DIGIT);
}

bool valid(int x,int y)
{
    if((x==0||x==n+1)&&(y==0||y==m+1))return 0;

    return 0<=x&&x<=n+1&&0<=y&&y<=m+1;
}

bool valid_proper(int x,int y)
{
    return 1<=x&&x<=n&&1<=y&&y<=m;
}
vector< pair<int/*mask*/,pair<int/*x*/,int/*y*/> > > active[MX];

void push(int x1,int y1,int x2,int y2)
{
    if(valid_proper(x2,y2)==0)return;

    //t=0
    for(int s=1;s<16;s++)
        if(dist[s][x1][y1]>=0)
        {
            int cur=dist[s][x1][y1]+cost(x2,y2);

            if(cur>=MX)continue;

            if(dist[s][x2][y2]!=-1)continue;

            active[cur].push_back({s,{x2,y2}});
        }

    for(int s=1;s<16;s++)
        for(int t=1;t<16;t++)
            if(dist[s][x1][y1]>=0&&dist[t][x2][y2]>=0)
        {
            int cur=dist[s][x1][y1]+dist[t][x2][y2];

            if(t==0)cur+=cost(x2,y2);

            if(cur>=MX)continue;

            if(dist[s|t][x2][y2]!=-1)continue;

            active[cur].push_back({s|t,{x2,y2}});
        }
}
void dij_all()
{
    for(int t=0;t<MX;t++)
        for(int w=0;w<active[t].size();w++)
        {
            int id=active[t][w].first;

            pair<int,int> tp=active[t][w].second;

            int c=t;

            int x=tp.first;
            int y=tp.second;

            if(dist[id][x][y]!=-1)continue;

            //cout<<t<<" -> "<<id<<" "<<tp.first<<" "<<tp.second<<endl;

            //cout<<"! "<<x<<" "<<y<<" "<<c<<endl;

            dist[id][x][y]=c;

            for(int i=0;i<4;i++)
            {
                //cout<<"test "<<x+x_move[i]<<" "<<y+y_move[i]<<" "<<valid(x+x_move[i],y+y_move[i])<<endl;
                if(valid(x+x_move[i],y+y_move[i]))
                {
                    push(x,y,x+x_move[i],y+y_move[i]);
                    //cout<<"pushed "<<c<<" "<<x+x_move[i]<<" "<<y+y_move[i]<<endl;
                }
            }
        }
    /*
    cout<<id<<" "<<DIGIT<<endl;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)cout<<dist[id][i][j]<<" ";cout<<endl;
    }
    cout<<"---"<<endl;
    */

    for(int i=0;i<MX;i++)active[i]={};
}

void calc_type_0()
{
    for(int i=1;i<=n;i++)
        active[0].push_back({1,{i,0}});
}

void calc_type_1()
{
    for(int j=1;j<=m;j++)
        active[0].push_back({2,{0,j}});
}

void calc_type_2()
{
    for(int i=1;i<=n;i++)
        active[0].push_back({4,{i,m+1}});
}

void calc_type_3()
{
    for(int j=1;j<=m;j++)
        active[0].push_back({8,{n+1,j}});
}

int ask(int d)
{
    for(int t=0;t<16;t++)
        for(int i=0;i<=n+1;i++)
            for(int j=0;j<=m+1;j++)
                dist[t][i][j]=-1;

    DIGIT=d;

    calc_type_0();
    calc_type_1();
    calc_type_2();
    calc_type_3();

    dij_all();

    int ret=9*n*m;

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            ret=min(ret,dist[15][i][j]);

    //cout<<DIGIT<<" -> "<<ret<<endl;
    //system("pause");

    return ret;
}
int main()
{
    scanf("%i%i",&n,&m);

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
        {
            char c=getchar();

            while('0'>c||c>'9')c=getchar();

            inp[i][j]=c-'0';
        }

    int outp=9*n*m;

    for(int d=0;d<=9;d++)
        outp=min(outp,ask(d));

    printf("%i\n",outp);
    return 0;
}