#include<bits/stdc++.h>
using namespace std;

const int nmax=5e2+42,MX=10000+42;

int WWW=clock();

int x_move[4]={0,0,1,-1};
int y_move[4]={1,-1,0,0};

int n,m;

int inp[nmax][nmax];

int dist[16][nmax][nmax];

int DIGIT;

int mem_cost[nmax][nmax];

int cost(int x,int y)
{
    return abs(inp[x][y]-DIGIT);
}

bool valid(int x,int y)
{
    return 1<=x&&x<=n&&1<=y&&y<=m;
}

vector< pair<char/*mask*/,pair<short/*x*/,short/*y*/> > > active[MX];

int OUTP=1e9;

void test(int cur,int mask,int x,int y)
{
    //cout<<"test "<<cur<<" "<<mask<<" "<<x<<" "<<y<<endl;

    if(cur>=MX)return;

    if(cur>=OUTP)return;

    if(dist[mask][x][y]<=cur)return;

    dist[mask][x][y]=cur;

    active[cur].push_back({mask,{x,y}});
}

bool been[16][nmax][nmax];

int other[16][16],pointer_other[16];

void push(int x1,int y1,int x2,int y2,int s)
{
    //t=0

    int cur=dist[s][x1][y1]+mem_cost[x2][y2];

    test(cur,s,x2,y2);

    //for(auto t:other[s])
    for(int w=1;w<=pointer_other[s];w++)
    {
        int t=other[s][w];

        if(dist[s][x1][y1]<MX&&dist[t][x2][y2]<MX)
        {
            int cur=dist[s][x1][y1]+dist[t][x2][y2];

            test(cur,s|t,x2,y2);
        }
    }
}
void dij_all()
{
    for(int t=0;t<OUTP;t++)
    {
        if(1.0*(clock()-WWW)/CLOCKS_PER_SEC>1.9)
        {
            printf("%i\n",OUTP);
            exit(0);
        }

        for(int w=0;w<active[t].size();w++)
        {
            int id=active[t][w].first;

            int x=active[t][w].second.first;
            int y=active[t][w].second.second;

            if(been[id][x][y])continue;

            dist[id][x][y]=t;

            //cout<<t<<" -> "<<id<<" "<<tp.first<<" "<<tp.second<<endl;

            if(id==15)
            {
                //cout<<IN<<endl;

                OUTP=t;
                return;
            }

            //cout<<"! "<<x<<" "<<y<<" "<<c<<endl;

            been[id][x][y]=1;

            for(int i=0;i<4;i++)
            {
                //cout<<"test "<<x+x_move[i]<<" "<<y+y_move[i]<<" "<<valid(x+x_move[i],y+y_move[i])<<endl;
                if(valid(x+x_move[i],y+y_move[i]))
                {
                    push(x,y,x+x_move[i],y+y_move[i],id);
                    //cout<<"pushed "<<c<<" "<<x+x_move[i]<<" "<<y+y_move[i]<<endl;
                }
            }
        }
    }

    //cout<<TOTAL<<" "<<RUN<<" "<<IN<<endl;

    /*
    cout<<id<<" "<<DIGIT<<endl;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)cout<<dist[id][i][j]<<" ";cout<<endl;
    }
    cout<<"---"<<endl;
    */
}

void calc_type_0()
{
    for(int i=1;i<=n;i++)
        active[0].push_back({1,{i,0}});
}

void calc_type_1()
{
    for(int j=1;j<=m;j++)
        active[0].push_back({2,{0,j}});
}

void calc_type_2()
{
    for(int i=1;i<=n;i++)
        active[0].push_back({4,{i,m+1}});
}

void calc_type_3()
{
    for(int j=1;j<=m;j++)
        active[0].push_back({8,{n+1,j}});
}

int ask(int d)
{
    for(int i=0;i<MX;i++)
        active[i]={};

    for(int t=0;t<16;t++)
        for(int i=0;i<=n+1;i++)
            for(int j=0;j<=m+1;j++)
            {
                dist[t][i][j]=MX+42;
                been[t][i][j]=0;
            }

    DIGIT=d;

    for(int i=0;i<=n+1;i++)
        for(int j=0;j<=m+1;j++)
            mem_cost[i][j]=abs(inp[i][j]-DIGIT);

    calc_type_0();
    calc_type_1();
    calc_type_2();
    calc_type_3();

    dij_all();

    return OUTP;
}

int seen[10];

bool cmp(int a,int b)
{
    return seen[a]>seen[b];
}
int main()
{
    scanf("%i%i",&n,&m);

    for(int s=1;s<16;s++)
        for(int t=1;t<16;t++)
            if((s&t)==0)
            {
                pointer_other[s]++;
                other[s][pointer_other[s]]=t;
            }
    /*
    n=200;
    m=200;
    */

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
        {
            char c=getchar()/*'?'*/;

            //c=rand()%10+'0';

            while('0'>c||c>'9')c=getchar();

            inp[i][j]=c-'0';

            seen[c-'0']++;
        }

    int outp=9*n*m;

    vector<int> my={};

    for(int i=0;i<10;i++)my.push_back(i);

    sort(my.begin(),my.end(),cmp);

    for(auto k:my)
    {
        outp=min(outp,ask(k));
    }
    printf("%i\n",outp);
    return 0;
}
