#include<bits/stdc++.h>
using namespace std;

const int nmax=5e5+42;

int n,q;

vector<int> adj[nmax];

char inp[nmax];

int up[20][nmax];

int level[nmax];

int SZ[nmax];

int pref_with_me[nmax],pref_without_me[nmax];

void dfs(int node,int par,int h,int sum)
{
    pref_without_me[node]=sum;

    if(inp[node]=='+')sum++;
    else sum--;

    pref_with_me[node]=sum;

    level[node]=h;

    up[0][node]=par;

    for(int i=1;i<20;i++)up[i][node]=up[i-1][up[i-1][node]];

    SZ[node]=1;

    for(auto k:adj[node])
        if(k!=par)
        {
            dfs(k,node,h+1,sum);
            SZ[node]+=SZ[k];
        }
}

int lca(int u,int v)
{
    if(level[u]<level[v])swap(u,v);

    for(int i=19;i>=0;i--)
        if(level[u]-(1<<i)>=level[v])u=up[i][u];

    if(u==v)return u;

    for(int i=19;i>=0;i--)
        if(up[i][u]!=up[i][v])u=up[i][u],v=up[i][v];

    return up[0][u];
}
int main()
{
    scanf("%i%i",&n,&q);

    for(int i=1;i<=n;i++)
    {
        char c=getchar();
        while(c!='+'&&c!='-')c=getchar();
        inp[i]=c;
    }

    for(int i=1;i<n;i++)
    {
        int u,v;
        scanf("%i%i",&u,&v);

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    dfs(1,1,0,0);

    for(int i=1;i<=q;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);

        int l=lca(u,v);

        int ret=0;

        int cur=u;

        while(cur!=l)
        {
            if(pref_with_me[u]>pref_without_me[cur])ret++;

            cur=up[0][cur];
        }

        if(pref_with_me[u]>pref_without_me[cur])ret++;

        //cout<<"ret= "<<ret<<endl;

        cur=v;

        while(cur!=l)
        {
            if(pref_with_me[u]-pref_without_me[l]>pref_with_me[l]-pref_with_me[cur])ret++;

            cur=up[0][cur];
        }
        printf("%i\n",ret);
    }
    return 0;
}
