#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

const int maxn = 1e6;
int n, m, t;
vector<int> e[maxn];
int f1[maxn], f2[maxn];

int dp[maxn];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m >> t;
    for(int i = 0; i < n; i ++)
    {
        int k;
        cin >> k;
        e[i].resize(k);
        for(int j = 0; j < k; j ++)
        {
            cin >> e[i][j];
        }
        random_shuffle(e[i].begin(), e[i].end());
    }
    for(int i = 0; i < t; i ++)
    {
        cin >> f1[i] >> f2[i];
    }

    int ans = 0;
    for(int i = 0; i < t; i ++)
    {
        int nw = dp[f2[i]];
        nw = max(nw, dp[f1[i]] + 1);
        for(auto l: e[f1[i]])
        {
            nw = max(nw, dp[l] + 1);
            if(nw > ans)    break;
        }
        dp[f2[i]] = nw;
        ans = max(ans, nw);
        /*for(int j = 0; j < n; j ++)
        {
            cout << dp[j] << " ";
        }
        cout << endl;*/
    }
    cout << ans;


}
/**
6 6 5
3 1 2 3
2 0 4
2 0 4
1 0
3 1 2 5
1 4
0 4
5 3
2 1
1 3
0 5
*/
