#include <bits/stdc++.h>
using namespace std;

const int N=(5e5)+5;

vector <int> g[N];
string s;
queue <int> q;
int iter;
int used[N],par[N],temp[N];
vector < pair <int,int> > query;

int BFS(int v,int target)
{
 int i,ans,x;
 bool reached=false;

 ans=0;
 x=target;
  while(x!=0)
  {
    if(temp[x]>0)
     ans++;

    if(x==v)
    {
     reached=true;
     break;
    }
  }

  if(reached)
   return ans;

 iter++;

 q.push(v);
 used[v]=iter;
 par[v]=0;

  if(s[v-1]=='+')
   temp[v]=1;
  else
   temp[v]=-1;

  while(!q.empty())
  {
   v=q.front();
   q.pop();

    for(i=0;i<g[v].size();i++)
    {
     if(used[g[v][i]]!=iter)
     {
      q.push(g[v][i]);
      used[g[v][i]]=iter;
      par[g[v][i]]=v;

       if(s[g[v][i]-1]=='+')
        temp[g[v][i]]=temp[v]+1;
       else
        temp[g[v][i]]=temp[v]-1;
     }
    }
  }

 ans=0;
 v=target;
  while(v!=0)
  {
    if(temp[v]>0)
     ans++;

   v=par[v];
  }

 return ans;
}

int main()
{

ios::sync_with_stdio(false);
cin.tie(nullptr);

int n,q,i,u,v;

cin>>n>>q;
cin>>s;

 for(i=1;i<n;i++)
 {
  cin>>u>>v;

   if(u>v)
    swap(u,v);

  g[u].push_back(v);
  g[v].push_back(u);
  query.push_back(make_pair(u,v));
 }

sort(query.begin(),query.end());

 for(i=1;i<=q;i++)
 {
  cin>>u>>v;
  cout<<BFS(u,v)<<"\n";
 }

return 0;
}
