#include <iostream>
#include <set>
#include <vector>

using namespace std;

const int k_N = 5e5 + 3;

int n, m, t;
set<pair<int, int> > s;

pair<int, int> f[k_N];
int dp[k_N], v[k_N];

vector<int> adj[k_N];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> t;
    for(int i = 0; i < n; ++i){
        int k;
        cin >> k;
        for(int j = 0; j < k; ++j){
            int x;
            cin >> x;

            s.insert(make_pair(i, x));
            adj[i].push_back(x);
        }
    }

    for(int i = 0; i < t; ++i)
        cin >> f[i].first >> f[i].second;

    int ans = 0;
    for(int i = t - 1; i >= 0; --i){
        dp[i] = v[f[i].second] + 1;

        for(int j = 0; j < adj[f[i].first].size(); ++j){
            int to = adj[f[i].first][j];
            v[to] = max(v[to], dp[i]);
        }
        v[f[i].first] = max(v[f[i].first], dp[i]);

        //cout << dp[i] << "\n";
        ans = max(dp[i], ans);
    }

    cout << ans << "\n";
}
