#include <iostream>
#include <set>
#include <vector>

using namespace std;

const int k_N = 5e5 + 3;
const int k_B = 1000;

int n, m, t;
set<pair<int, int> > s;

pair<int, int> f[k_N];
int dp[k_N], v[k_N], v2[k_N];

vector<int> adj[k_N], adj2[k_N];
bool big[k_N];

vector<pair<int, int> > edges;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> t;
    for(int i = 0; i < n; ++i){
        int k;
        cin >> k;

        if(k >= k_B)
            big[i] = true;

        for(int j = 0; j < k; ++j){
            int x;
            cin >> x;

            edges.push_back(make_pair(i, x));
        }
    }

    for(int i = 0; i < 2 * m; ++i){
        if(!big[edges[i].first])
            adj[edges[i].first].push_back(edges[i].second);
        if(big[edges[i].second])
            adj2[edges[i].first].push_back(edges[i].second);
    }

    for(int i = 0; i < t; ++i)
        cin >> f[i].first >> f[i].second;

    int ans = 0;
    for(int i = t - 1; i >= 0; --i){
        for(int j = 0; j < adj2[f[i].second].size(); ++j){
            int to = adj2[f[i].second][j];
            v[f[i].second] = max(v2[to], v[f[i].second]);
        }

        dp[i] = v[f[i].second] + 1;
        v2[f[i].second] = max(v2[f[i].second], dp[i]);

        for(int j = 0; j < adj[f[i].first].size(); ++j){
            int to = adj[f[i].first][j];
            v[to] = max(v[to], dp[i]);
        }
        v[f[i].first] = max(v[f[i].first], dp[i]);

        ans = max(dp[i], ans);
    }

    cout << ans << "\n";
}
