#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e6 + 3;

int n, m, t;
vector <int> adj[maxn];
pair <int, int> flight[maxn];
void read()
{
    cin >> n >> m >> t;
    for (int i = 1; i <= n; i++)
    {
        int k;
        cin >> k;

        for (int j = 1; j <= k; j++)
        {
            int to;
            cin >> to;
            to++;

            adj[i].push_back(to);
        }
    }

    for (int i = 1; i <= t; i++)
    {
        cin >> flight[i].first >> flight[i].second;
        flight[i].first++;
        flight[i].second++;
    }
}

vector <int> dp[maxn];
void solve()
{
    for (int i = 1; i <= n; i++)
    dp[i].resize(t + 2);

    for (int i = 1; i <= n; i++)
        dp[i][t+1] = 0;

    for (int j = t; j >= 1; j--)
        for (int i = 1; i <= n; i++)
        {
            dp[i][j] = dp[i][j+1];
            if (flight[j].first == i)
                dp[i][j] = max(dp[i][j], dp[flight[j].second][j+1] + 1);

            for (auto k: adj[i])
                if (k == flight[j].first)
            {
                dp[i][j] = max(dp[i][j], dp[flight[j].second][j+1] + 1);
                break;
            }
        }

    int ans = 0;
    for (int i = 1; i <= n; i++)
        ans = max(ans, dp[i][1]);

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
