#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int maxn = 1e6 + 3;

int n, m, t;
vector <int> adj[maxn];
pair <int, int> flight[maxn];
void read()
{
    cin >> n >> m >> t;
    for (int i = 1; i <= n; i++)
    {
        int k;
        cin >> k;

        for (int j = 1; j <= k; j++)
        {
            int to;
            cin >> to;
            to++;

            adj[i].push_back(to);
        }
    }

    for (int i = 1; i <= t; i++)
    {
        cin >> flight[i].first >> flight[i].second;
        flight[i].first++;
        flight[i].second++;
    }
}

int dp[maxn], nxt_dp[maxn];
void solve()
{
    for (int j = t; j >= 1; j--)
    {
        int val = dp[flight[j].second] + 1;
        for (auto i: adj[flight[j].first])
            dp[i] = max(dp[i], val);

        dp[flight[j].first] = max(dp[flight[j].first], val);
    }

    int ans = 0;
    for (int i = 1; i <= n; i++)
        ans = max(ans, dp[i]);

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
