#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5e5 + 5;

int n, q;
vector <int> graph[MAXN];
int tp[MAXN];
bool fl = true;
int N;

void read_input()
{
	cin >> n >> q;

	int v, w;
	char c;
	for(int i = 1; i <= n; i++)
	{
		cin >> c;
		tp[i] = (c == '+')? 1 : -1;
	}

	for(int i = 0; i < n - 1; i++)
	{
		cin >> v >> w;
		graph[v].push_back(w);
		graph[w].push_back(v);
	}
	for(int i = 1; i <= n; i++)
	{
		for(auto x : graph[v])
		{
			if(x != i - 1 && x != i + 1)
			{
				fl = false;
			}
		}
	}
	N = sqrt(n);
}

int anse, a, b;

void dfs(int v, int p, int sum, int br)
{
	sum += tp[v];
	
	if(sum > 0) br++;
	if(v == b)
	{
		anse = br;
	}

	for(auto x : graph[v])
	{
		if(x != p)
		dfs(x, v, sum, br);
	}
}

vector <int> v[MAXN];
int sum[MAXN];
vector <int> cnt[MAXN], cnt2[MAXN];
int in[MAXN];

void precomp()
{
	for(int i = 1; i <= n; i++)
	{
		in[i] = i / N;
		int comp = i / N;
		v[comp].push_back(tp[i]);
		sum[comp] += tp[i];
	}
	for(int i = 0; i < N; i++)
	{
		int sm = 0;
		for(int j = 0; j < v[i].size(); j++)
		{
			sm += v[i][j];
			cnt[i].push_back(sm);
		}
		sm = 0;
		for(int j = v[i].size() - 1; j >= 0; i--)
		{
			sm += v[i][j];
			cnt2[i].push_back(sm);
		}
		sort(cnt[i].begin(), cnt[i].end());
		sort(cnt2[i].begin(), cnt2[i].end());
	}
}

int b_search(vector <int> tv, int key)
{
	int l = 0, r = tv.size() - 1;
	int ans = -1;

	while(l <= r)
	{
		int middle = (l + r) >> 1;

		if(tv[middle] > -key)
		{
			ans = middle;
			l = middle + 1;
		}
		else
		{
			r = middle - 1;
		}
	}
	return ans + 1;
}

void solve()
{
	if(fl)
	{
		precomp();
		for(int i = 0; i < q; i++)
		{
			cin >> a >> b;
			if(a < b)
			{
				int br = 0;
				int sm = 0;
				int tmp = in[a];
				for(int j = a; in[j] == tmp; j++)
				{
					sm += tp[j];
					if(sm > 0) br++;
				}
				for(int j = tmp + 1; j < in[b] j++)
				{
					br += b_search(cnt[j], sm);	
					sm += sum[j];
				}
				for(int j = N * (in[b]); j <= b; j++)
				{
					sm += tp[j];
					if(sm > 0) br++;
				}

				cout << br << "\n";
			}
			else
			{
				int br = 0;
				int sm = 0;
				int tmp = in[b];
				for(int j = b; in[j] == tmp; j--)
				{
					sm += tp[j];
					if(sm > 0) br++;
				}
				for(int j = tmp - 1; j > in[a]; j--)
				{
					br += b_search(cnt[j], sm);	
					sm += sum[j];
				}
				int st = a;
				while(in[(st + 1)] == in[a]) st++;
				for(int j = st; j >= a; j--)
				{
					sm += tp[j];
					if(sm > 0) br++;
				}
				cout << br << "\n";
			}
		}
	}
	else
	for(int i = 0; i < q; i++)
	{
		cin >> a >> b;
		dfs(a, a, 0, 0); 
		cout << anse << "\n";
	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	read_input();
	solve();

	

	return 0;
}
