#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5e5 + 10;

int n, q;
vector <int> graph[MAXN];
int tp[MAXN];
int tp2[MAXN];
bool fl = true;
int N;

void read_input()
{
	cin >> n >> q;

	int v, w;
	char c;
	for(int i = 1; i <= n; i++)
	{
		cin >> c;
		tp[i] = (c == '+')? 1 : -1;
		tp2[n - i + 1] = tp[i];
	}

	for(int i = 0; i < n - 1; i++)
	{
		cin >> v >> w;
		graph[v].push_back(w);
		graph[w].push_back(v);
	}
	for(int i = 1; i <= n; i++)
	{
		for(auto x : graph[i])
		{
			if(x != i - 1 && x != i + 1)
			{
				fl = false;
			}
		}
	}
	N = q/sqrt(n);
}

int anse, a, b;

void dfs(int v, int p, int sum, int br)
{
	sum += tp[v];
	
	if(sum > 0) br++;
	if(v == b)
	{
		anse = br;
	}

	for(auto x : graph[v])
	{
		if(x != p)
		dfs(x, v, sum, br);
	}
}

struct query
{
	int l, r, ind;

	query(int _l, int _r, int _ind)
	{
		l = _l; r = _r; ind = _ind;
	}

	bool operator<(query other) const
	{
		if(l / N != other.l / N)
		{
			return l < other.l;
		}
		else
		{
			return (r & 1)? r < other.r : r > other.r;
		}
	}
};

vector <query> v1, v2;
int L, R;
int st = 0;
int v[2*MAXN];
int summ;
int answer;

const int ADD = MAXN / 2;

void shft_l()
{
	answer -= v[st + ADD + 1];
	st--;
}

void shft_r()
{
	answer += v[st + ADD];
	st++;
}

void add(int tr)
{
	summ += tr;
	v[st + ADD + summ]++;
	if(summ > 0) answer++;
}

void rem(int tr)
{
	v[st + ADD + summ]--;
	if(summ > 0) answer--;
	summ -= tr;
}

int answ[MAXN];

void solve()
{
	if(fl)
	{
		L = 1; R = 0;
		for(int i = 0; i < q; i++)
		{
			cin >> a >> b;
			if(a < b)
			{
				v1.push_back(query(a, b, i));
			}
			else
			{
				v2.push_back(query(n - a + 1, n - b + 1, i));
			}
		}
		sort(v1.begin(), v1.end());
		sort(v2.begin(), v2.end());
		
		int zt = v1.size();
		for(int i = 0; i < zt; i++)
		{
			while(R < v1[i].r)
			{
				add(tp[R + 1]);
				R++;
			}
			while(R > v1[i].r)
			{
				rem(tp[R]);
				R--;
			}
			while(L < v1[i].l)
			{
				int zn = tp[L];
				if(zn == 1)
				{
					shft_l();
				}
				else
				{
					shft_r();
				}
				L++;
			}
			while(L > v1[i].l)
			{
				int zn = tp[L - 1];
				if(zn == 1)
				{
					shft_r();
				}
				else
				{
					shft_l();
				}
				L--;
			}
			answ[v1[i].ind] = answer;
		}
		summ = 0;
		answer = 0;
		L = 1, R = 0;

		for(int i = 0; i < 2 * MAXN; i++)
		{
			v[i] = 0;
		}
		zt = v2.size();

		for(int i = 0; i < zt; i++)
		{
			while(R < v2[i].r)
			{
				add(tp2[R + 1]);
				R++;
			}
			while(R > v2[i].r)
			{
				rem(tp2[R]);
				R--;
			}
			while(L < v2[i].l)
			{
				int zn = tp2[L];
				if(zn == 1)
				{
					shft_l();
				}
				else
				{
					shft_r();
				}
				L++;
			}
			while(L > v2[i].l)
			{
				int zn = tp2[L - 1];
				if(zn == 1)
				{
					shft_r();
				}
				else
				{
					shft_l();
				}
				L--;
			}
			answ[v2[i].ind] = answer;
		}

		for(int i = 0; i < q; i++)
		{
			cout << answ[i] << "\n";
		}
	}
	else
	{
		for(int i = 0; i < q; i++)
		{
			cin >> a >> b;
			dfs(a, a, 0, 0); 
			cout << anse << "\n";
		}
	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	read_input();
	solve();

	

	return 0;
}
