#include <bits/stdc++.h>

using namespace std;

#define MAX 250100

#define PA pair<int, int>

vector<int > gr[MAX];

int n, m, st[MAX], dist[5][MAX], ans = MAX * 10, tn, ty;

char mat[510][510];

bool used[MAX];

void conn(int i, int j, int st)
{
    gr[st].push_back(i * m + j);
    gr[i * m + j].push_back(st);
}

void connect(int i, int j, int x, int y)
{
    if(x < 0 || y < 0)return;
    if(x >= n || y >= m)return;
    gr[i * m + j].push_back(x * m + y);
}

void dij(int ch)
{
    priority_queue<PA, vector<PA>, greater<PA> > q;
    int node;
    for(int p = 0; p < 4; p++)
    {
        for(int j = 0; j < 4; j++)
        {
            if(j == p)continue;
            while(gr[MAX - 5 + j].size() > 0)gr[MAX - 5 + j].pop_back();

        }
        while(q.size() > 0)q.pop();
        for(int i = 0; i < MAX;i++)used[i] = 0;
        for(int i = 0; i < MAX;i++)dist[p][i] = INT_MAX / 100;
        dist[p][MAX - 5 + p] = 0;
        q.push({0, MAX - 5 + p});
        while(q.size() != 0)
        {
            node = q.top().second;
            q.pop();
            if(used[node] == 1)continue;
            used[node] = 1;
            for(int i = 0; i < gr[node].size(); i++)
            {
                if(used[gr[node][i]] == 0)
                {
                    if(dist[p][gr[node][i]] > dist[p][node] + st[gr[node][i]])
                    {
                        dist[p][gr[node][i]] = dist[p][node] + st[gr[node][i]];
                        q.push({dist[p][gr[node][i]], gr[node][i]});
                    }
                }
            }
        }
        for(int i = 0; i < n; i++)conn(i, 0, MAX - 5);
        for(int i = 0; i < n; i++)conn(i, m - 1, MAX - 4);
        for(int i = 0; i < m; i++)conn(0, i, MAX - 3);
        for(int i = 0; i < m; i++)conn(n - 1, i, MAX - 2);
    }
}

void back_to(int p, int node)
{
    while(node != p)
    {
        tn = st[node];
        st[node] = 0;
        used[node] = 1;
        for(int i = 0; i < gr[node].size(); i++)
        {
            if(dist[0][node] == tn + dist[0][gr[node][i]] && used[gr[node][i]] == 0)
            {
                node = gr[node][i];

                break;
            }
        }
    }
}

int main()
{
    scanf("%d%d",&n, &m);
    for(int i = 0; i < n; i++)cin>>mat[i];
    for(int i = 0; i <= 9; i++)
    {
        for(int j = 0; j < MAX; j++)while(gr[i].size() > 0)gr[i].pop_back();
        for(int j = 0; j < n; j++)
        {
            for(int k = 0; k < m; k++)
            {
                connect(j, k, j - 1, k);
                connect(j, k, j , k - 1);
                connect(j, k, j + 1, k);
                connect(j, k, j, k + 1);
                st[j* m + k] = abs(mat[j][k] - '0' - i);
            }
        }
        for(int i = 0; i < n; i++)conn(i, 0, MAX - 5);
        for(int i = 0; i < n; i++)conn(i, m - 1, MAX - 4);
        for(int i = 0; i < m; i++)conn(0, i, MAX - 3);
        for(int i = 0; i < m; i++)conn(n - 1, i, MAX - 2);
        dij(i);
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < m; j++)
            {
                ans = min(ans, dist[0][i * m + j] + dist[1][i * m + j] + dist[2][i * m + j] + dist[3][i * m + j] - 3 * st[i*m + j]);
            }
        }
        for(int i = 0; i < MAX;i++)used[i] = 0;
        // << dist[0] [6] << endl;
        //system("pause");

        back_to(MAX-5, MAX - 4);
        ty = dist[0][MAX - 4];
        dij(i);
        ty += dist[2][MAX - 2];
        ans = min(ans, ty);

    }

    printf("%d\n", ans);
    return 0;
}
