#include <bits/stdc++.h>
using namespace std;
int n, m, Q, sign [500005], sum [500005], par [500005], first [500005];
vector <int> adj [500005];
pair <int, int> q [500005];
vector <pair <int, int> > euler;
void root (int a, int d){
    sum [a] = sum [par [a]] + sign [a];
    first [a] = euler.size ();
    euler.push_back ({d, a});
    for (int i : adj [a]){
        if (i != par [a]){
            par [i] = a;
            root (i, d + 1);
            euler.push_back ({d, a});
        }
    }
}
pair <int, int> tree [4000006];
void build (int l, int r, int pos){
    if (l == r){
        tree [pos] = euler [l];
        return;
    }
    int mid = l + r >> 1;
    build (l, mid, pos << 1);
    build (mid + 1, r, pos << 1 | 1);
    tree [pos] = min (tree [pos << 1], tree [pos << 1 | 1]);
}
pair <int, int> query (int l, int r, int pos, int ql, int qr){
    if (l >= ql && r <= qr) return tree [pos];
    if (l > qr || r < ql) return {n, n};
    int mid = l + r >> 1;
    return min (query (l, mid, pos << 1, ql, qr), query (mid + 1, r, pos << 1 | 1, ql, qr));
}
struct add{
    int l, r, sign, idx;
};
vector <add> adds [500005];
int ans [500005];
int tree2 [4000006];
void upd2 (int l, int r, int pos, int x, int val){
    if (l == r){
        tree2 [pos] += val;
        return;
    }
    int mid = l + r >> 1;
    if (x <= mid) upd2 (l, mid, pos << 1, x, val);
    else upd2 (mid + 1, r, pos << 1 | 1, x, val);
    tree2 [pos] = tree2 [pos << 1] + tree2 [pos << 1 | 1];
}
int query2 (int l, int r, int pos, int ql, int qr){
    if (l >= ql && r <= qr) return tree2 [pos];
    if (l > qr || r < ql) return 0;
    int mid = l + r >> 1;
    return query2 (l, mid, pos << 1, ql, qr) + query2 (mid + 1, r, pos << 1 | 1, ql, qr);
}
void dfs (int a){
    upd2 (-n, n, 1, sum [a], 1);
    for (auto x : adds [a]){
        ans [x.idx] += x.sign * query2 (-n, n, 1, x.l, x.r);
    }
    for (int i : adj [a]){
        if (i != par [a]) dfs (i);
    }
    upd2 (-n, n, 1, sum [a], -1);
}
int main (){

	ios::sync_with_stdio (false);
	cin.tie (0);

	cin >> n >> Q;
	string str;
	cin >> str;
	for (int i = 0; i < n; i ++){
        if (str [i] == '+') sign [i + 1] = 1;
        else sign [i + 1] = -1;
	}
	for (int i = 1; i < n; i ++){
        int u, v;
        cin >> u >> v;
        adj [u].push_back (v);
        adj [v].push_back (u);
	}
	root (1, 0);
	m = euler.size () - 1;
	build (0, m, 1);
	for (int i = 0; i < Q; i ++){
        cin >> q [i].first >> q [i].second;
        int l = first [q [i].first], r = first [q [i].second];
        if (l > r) swap (l, r);
        int lca = query (0, m, 1, l, r).second;
        if (lca != 1) adds [par [lca]].push_back ({-n, sum [q [i].first] - 1, -1, i});
        if (q [i].first != 1) adds [par [q [i].first]].push_back ({-n, sum [q [i].first] - 1, 1, i});
        int sum1 = sum [q [i].first];
        if (lca != 1) sum1 -= sum [par [lca]];
        int need = 1 - sum1 + sum [lca];
        if (lca != 1) adds [par [lca]].push_back ({need, n, -1, i});
        adds [q [i].second].push_back ({need, n, 1, i});
    }
    dfs (1);
    for (int i = 0; i < Q; i ++) cout << ans [i] << '\n';

}
