#include<bits/stdc++.h>
using namespace std;

const int nmax=5e2+42;

int x_move[4]={0,0,1,-1};
int y_move[4]={1,-1,0,0};

int n,m;

int inp[nmax][nmax];

int dist[4][nmax][nmax];

int DIGIT;

int cost(int x,int y)
{
    return abs(inp[x][y]-DIGIT);
}

priority_queue< pair<int/*cost*/,pair<int/*x*/,int/*y*/> > > pq;

bool valid(int x,int y)
{
    return 1<=x&&x<=n&&1<=y&&y<=m;
}
void dij(int id)
{
    while(pq.size())
    {
        pair<int/*cost*/,pair<int/*x*/,int/*y*/> > tp=pq.top();
        pq.pop();

        int c=-tp.first;

        int x=tp.second.first;
        int y=tp.second.second;

        c+=cost(x,y);

        if(dist[id][x][y]!=-1)continue;

        dist[id][x][y]=c;

        for(int i=0;i<4;i++)
            if(valid(x+x_move[i],y+y_move[i]))
            {
                pq.push({-c,{x+x_move[i],y+y_move[i]}});
            }
    }
    /*
    cout<<id<<" "<<DIGIT<<endl;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)cout<<dist[id][i][j]<<" ";cout<<endl;
    }
    cout<<"---"<<endl;
    */
}

void calc_type_0()
{
    for(int i=1;i<=n;i++)
        pq.push({0,{i,1}});

    dij(0);
}

void calc_type_1()
{
    for(int j=1;j<=m;j++)
        pq.push({0,{1,j}});

    dij(1);
}

void calc_type_2()
{
    for(int i=1;i<=n;i++)
        pq.push({0,{i,m}});

    dij(2);
}

void calc_type_3()
{
    for(int j=1;j<=m;j++)
        pq.push({0,{n,j}});

    dij(3);
}


int ask(int d)
{
    for(int t=0;t<4;t++)
        for(int i=1;i<=n;i++)
            for(int j=1;j<=m;j++)
                dist[t][i][j]=-1;

    DIGIT=d;

    calc_type_0();
    calc_type_1();
    calc_type_2();
    calc_type_3();

    int ret=9*n*m;

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
        {
            int cur=dist[0][i][j]+dist[1][i][j]+dist[2][i][j]+dist[3][i][j];

            cur=cur-3*cost(i,j);

            ret=min(ret,cur);
        }
    return ret;
}
int main()
{
    scanf("%i%i",&n,&m);

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
        {
            char c=getchar();

            while('0'>c||c>'9')c=getchar();

            inp[i][j]=c-'0';
        }

    int outp=9*n*m;

    for(int d=0;d<=9;d++)
        outp=min(outp,ask(d));

    printf("%i\n",outp);
    return 0;
}
