#include<iostream>
#include<queue>
using namespace std;
const int maxn = 600;
int n, m;
int g[maxn][maxn];
int g2[maxn][maxn];

int dist[4][maxn][maxn];

int dir[4][2] = {{+1,0},{-1,0},{0,+1},{0,-1}};

const int inf = 1e8;

void fnd(int st)
{
    priority_queue<pair<int, pair<int,int> > > q;
    if(st < 2)
    {
        for(int i = 0; i < n; i ++)
        {
            if(st == 0)
            {
                q.push({-g2[i][0], {i, 0} });
            } else {
                q.push({-g2[i][m - 1], {i, m - 1} });
            }
        }
    } else {
        for(int i = 0; i < m; i ++)
        {
            if(st == 2)
            {
                q.push({-g2[0][i], {0, i} });
            } else {
                q.push({-g2[n - 1][i], {n - 1,i} });
            }
        }
    }
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < m; j ++)
        {
            dist[st][i][j] = inf;
        }
    }

    while(!q.empty())
    {
        auto curr = q.top();
        q.pop();
        int x = curr.second.first, y = curr.second.second;
        int d = curr.first;
        if(dist[st][x][y] != inf)   continue;
        dist[st][x][y] = -d;

        for(int i = 0; i < 4; i ++)
        {
            int x2 = x + dir[i][0], y2 = y + dir[i][1];
            if(x2 < 0 || y2 < 0 || x2 >= n || y2 >= m || dist[st][x2][y2] != inf)   continue;
            q.push({d - g2[x2][y2], {x2, y2}});
        }
    }
    return;
}

void print(int _[][maxn])
{
    for(int x = 0; x < n; x ++)
    {
        for(int y = 0; y < m; y ++)
        {
            cout << _[x][y] << " ";
        }
        cout << endl;
    }
    cout << endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < m; j ++)
        {
            char c;
            cin >> c;
            g[i][j] = c - '0';
        }
    }
    int ans = inf;
    for(int i = 9; i >= 0; i ++)
    {
        for(int x = 0; x < n; x ++)
        {
            for(int y = 0; y < m; y ++)
            {
                g2[x][y] = abs(g[x][y] - i);
            }
        }

        for(int j = 0; j < 4;j ++)
        {
            fnd(j);
        }


        int ta = inf;



        int _x, _y;
        for(int x = 0; x < n; x ++)
        {
            for(int y = 0; y < n; y ++)
            {
                int tt = -3 * g2[x][y];
                for(int j = 0; j < 4;j ++)
                {
                    tt += dist[j][x][y];
                }
                if(tt < ta)
                {
                    _x = x;
                    _y = y;
                }
                ta = min(ta, tt);
            }
        }

        /*cout << "====================\n"<< i << " " << ta << " " << _x << ", " << _y << ": \n";
        print(g2);
        print(dist[0]);
        print(dist[1]);
        print(dist[2]);
        print(dist[3]);*/

        ans = min(ans, ta);
    }
    while(ans >= inf){}
    cout << ans;

}
/**
5 5
3 3 2 3 3
3 3 2 3 3
2 2 2 2 2
3 3 2 3 3
3 3 2 3 3
*/
/**
7 7
9999919
1111919
9991919
9111119
9191999
9191111
9199999
*/
