#include<iostream>
#include<vector>
using namespace std;
int n, q;
const int maxn = 1e4;
int change[maxn];
vector<int> e[maxn];

int ans;

void dfs(int i, int from, int to, int curr, int ca)
{
    curr += change[i];
    if(curr > 0)    ca ++;
    if(i == to) ans = ca;
    for(auto ind: e[i])
    {
        if(ind == from) continue;
        dfs(ind, i, to, curr, ca);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> q;
    for(int i = 0; i < n; i ++)
    {
        char c;
        cin >> c;
        if(c == '+')    change[i] = 1;
        else    change[i] = -1;
    }
    for(int i = 0; i < n - 1; i ++)
    {
        int a, b;
        cin >> a >> b;
        a--;b--;
        e[a].push_back(b);
        e[b].push_back(a);
    }

    for(int i = 0; i < q; i ++)
    {
        int a, b;
        cin >> a >> b;
        a--;b--;
        ans = -1;
        dfs(a, -1, b, 0, 0);
        cout << ans << "\n";
    }

}
