#include<iostream>
#include<vector>
using namespace std;

const int maxn = 1e6;
int n, m, t;
vector<int> e[maxn];
int f1[maxn], f2[maxn];

int dp[maxn][2];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m >> t;
    for(int i = 0; i < n; i ++)
    {
        int k;
        cin >> k;
        e[i].resize(k);
        for(int j = 0; j < k; j ++)
        {
            cin >> e[i][j];
        }
    }
    for(int i = 0; i < t; i ++)
    {
        cin >> f1[i] >> f2[i];
    }

    for(int i = 0; i < t; i ++)
    {
        for(int j = 0; j < n; j ++)
        {
            dp[j][1] = max(dp[j][1], dp[j][0]);
            if(f1[i] == j)
            {
                dp[f2[i]][1] = max(dp[f2[i]][1], dp[j][0] + 1);
            }
            for(auto l: e[j])
            {
                if(f1[i] == l)
                {
                    dp[f2[i]][1] = max(dp[f2[i]][1], dp[j][0] + 1);
                }
            }
        }
        for(int j = 0; j < n; j ++)
        {
            dp[j][0] = dp[j][1];
            dp[j][1] = 0;
        }
        /*for(int j = 0; j < n; j ++)
        {
            cout << dp[j][0] << " ";
        }
        cout << endl << endl;*/
    }
    int ans = 0;
    for(int i = 0; i < n; i ++)
    {
        ans = max(ans, dp[i][0]);
    }
    cout << ans;


}
/**
6 6 5
3 1 2 3
2 0 4
2 0 4
1 0
3 1 2 5
1 4
0 4
5 3
2 1
1 3
0 5
*/
