#include <iostream>
#include <set>

using namespace std;

const int k_N = 5e5 + 3;

int n, m, t;
unordered_set<pair<int, int> > s;

pair<int, int> f[k_N];
int dp[k_N];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> t;
    for(int i = 0; i < n; ++i){
        int k;
        cin >> k;
        for(int j = 0; j < k; ++j){
            int x;
            cin >> x;

            s.insert(make_pair(i, x));
        }
    }

    for(int i = 0; i < t; ++i)
        cin >> f[i].first >> f[i].second;

    int ans = 0;
    for(int i = t - 1; i >= 0; --i){
        dp[i] = 0;
        for(int j = i + 1; j < t; ++j){
            if(f[i].second == f[j].first || s.count(make_pair(f[i].second, f[j].first))){
                dp[i] = max(dp[j], dp[i]);
            }
        }
        dp[i]++;
        //cout << dp[i] << " - " << i << endl;
        ans = max(dp[i], ans);
    }

    cout << ans << "\n";
}
