#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#pragma GCC optimization("O3")

#define pb push_back
#define fr first
#define sc second
#define ll long long
#define ld long double
#define bit(x) x&(-x)
#define bin(x, a) bitset<a>(x)
#define all(x) x.begin(), x.end()
#define de(x) cout << #x << " = " << x << endl;
#define matrix vector<vector<ll>>
#define row vector<ll>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x)  -> how many elements are smaller than x

const int MAXN = 2e6 + 6;

ll n, q, ans[MAXN], segmtree[4 * MAXN];
string t;
vector<pair<pair<ll, ll>, ll>> L, R;
vector<pair<pair<pair<ll, ll>, ll>, ll>> qs;
vector<ll> pref;

ll qry(ll node, ll l, ll r, ll ql, ll qr){
    if(qr < l || r < ql){
        return 0;
    }
    else if(ql <= l && r <= qr){
        return segmtree[node];
    }
    else{
        ll m = (l + r) / 2;
        ll ans1 = qry(2 * node, l, m, ql, qr);
        ll ans2 = qry(2 * node + 1, m + 1, r, ql, qr);
        return ans1 + ans2;
    }
}

void upd(ll node, ll l, ll r, ll x){
    if(l == r){
        ++ segmtree[node];
    }
    else{
        ll m = (l + r) / 2;
        if(l <= x && x <= m){
            upd(2 * node, l, m, x);
        }
        else{
            upd(2 * node + 1, m + 1, r, x);
        }
        segmtree[node] = segmtree[2 * node] + segmtree[2 * node + 1];
    }
}

void upd(ll x) { upd(1, 1, MAXN, x); }
ll qry(ll x) { return qry(1, 1, MAXN, x + 1, MAXN); }

int main(){
    ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);
    cin >> n >> q >> t;
    for(int i = 0; i < n - 1; i ++){ ll u, v; cin >> u >> v;}
    for(int i = 0; i < q; i ++){
        ll ql, qr; cin >> ql >> qr;
        if(ql <= qr){
            R.pb({{ql, qr}, i});
        }
        else{
            L.pb({{n - qr + 1, n - ql + 1}, i});
        }
    }
    pref.pb(0);
    for(auto x : t){
        pref.pb(pref.back() + (x == '+' ? +1 : -1));
    }
    for(auto [_, __] : R){
        qs.pb({{{_.fr, pref[_.fr - 1]}, -1}, __});
        qs.pb({{{_.sc, pref[_.fr - 1]},  1}, __});
    }
    sort(all(qs));
    int idx = 0;
    upd(pref[0] + MAXN / 2);
    for(int i = 1; i < pref.size(); i ++){
        while(qs[idx].fr.fr.fr < i){
            ++ idx;
        }
        while(qs[idx].fr.fr.fr == i && qs[idx].fr.sc == -1 && idx < qs.size()){
            ans[qs[idx].sc] -= qry(qs[idx].fr.fr.sc + MAXN / 2);
            ++ idx;
        }
        upd(pref[i] + MAXN / 2);
        while(qs[idx].fr.fr.fr == i && qs[idx].fr.sc == 1 && idx < qs.size()){
            ans[qs[idx].sc] += qry(qs[idx].fr.fr.sc + MAXN / 2);
            ++ idx;
        }
    }
    pref.resize(1, 0);
    reverse(all(t));
    for(auto x : t){
        pref.pb(pref.back() + (x == '+' ? +1 : -1));
    }
    /// for(auto x : pref) cout << x << " "; cout << endl;
    qs.clear();
    for(auto [_, __] : L){
        qs.pb({{{_.fr, pref[_.sc - 1]},  1}, __});
        qs.pb({{{_.sc, pref[_.sc - 1]}, -1}, __});
    }
    sort(all(qs));
    /// for(auto x : qs) cout << x.fr.fr.fr << " " << x.fr.fr.sc << " " << x.fr.sc << " " << x.sc << endl;
    idx = 0;
    memset(segmtree, 0, sizeof(segmtree));
    for(int i = 1; i < pref.size(); i ++){
        /// cout << i << " " << idx << " " << qs[idx].fr.fr.fr << endl;
        while(qs[idx].fr.fr.fr < i){
            ++ idx;
        }
        while(qs[idx].fr.fr.fr == i && qs[idx].fr.sc == -1 && idx < qs.size()){
            ans[qs[idx].sc] -= qry(qs[idx].fr.fr.sc + MAXN / 2);
            ++ idx;
        }
        upd(pref[i] + MAXN / 2);
        while(qs[idx].fr.fr.fr == i && qs[idx].fr.sc == 1 && idx < qs.size()){
            ans[qs[idx].sc] += qry(qs[idx].fr.fr.sc + MAXN / 2);
            ++ idx;
        }
    }
    for(int i = 0; i < q; i ++){
        cout << ans[i] << endl;
    }
}
/**
6 4
+-++--
1 2
2 3
3 4
4 5
5 6
1 6
6 1
5 1
2 4
*/
