#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#pragma GCC optimization("O3")

#define pb push_back
#define fr first
#define sc second
#define ll long long
#define ld long double
#define bit(x) x&(-x)
#define bin(x, a) bitset<a>(x)
#define all(x) x.begin(), x.end()
#define de(x) cout << #x << " = " << x << endl;
#define matrix vector<vector<ll>>
#define row vector<ll>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x)  -> how many elements are smaller than x

int n, m, t, ans;
vector<pair<int, int>> fl;
matrix G;

void rec(int u, int T, bool flag, int A){
    /// cout << u << " " << T << " " << flag << " " << A << endl;
    if(T == t){
        ans = max(ans, A);
        return;
    }
    else{
        if(flag){
            if(fl[T].fr == u){
                rec(fl[T].sc, T + 1, 0, A + 1);
            }
        }
        else{
            rec(u, T + 1, 0, A);
            for(auto v : G[u]){
                rec(v, T + 1, 0, A);
                rec(v, T, 1, A);
            }
            if(fl[T].fr == u){
                rec(fl[T].sc, T + 1, 0, A + 1);
            }
        }
    }
}

int main(){
    ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);
    cin >> n >> m >> t;
    G = matrix(n + 1);
    for(int i = 1; i <= n; i ++){
        int k; cin >> k;
        while(k --){
            int x; cin >> x;
            G[i].pb(x);
        }
    }
    for(int i = 0; i < t; i ++){
        int x, y; cin >> x >> y;
        fl.pb({x, y});
    }
    for(int s = 0; s <= n; s ++){
        rec(s, 0, 0, 0);
    }
    cout << ans << endl;
}
/**
6 6 5
3 1 2 3
2 0 4
2 0 4
1 0
3 1 2 5
1 4
0 4
5 3
2 1
1 3
0 5

*/
