#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 503;

int n, m;
int a[maxn][maxn];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        {
            char ch;
            cin >> ch;
            a[i][j] = ch - '0';
        }
}

int dist[10][4][maxn][maxn];
pair <int, int> par[10][4][maxn][maxn];
vector <pair <int, int> > adj[maxn][maxn];
void dijkstra(int dig, int from)
{
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
        dist[dig][from][i][j] = INT_MAX, par[dig][from][i][j] = {-1, -1};

    priority_queue <pair <int, pair <int, int> > > q;
    if (from == 0)
        for (int i = 1; i <= m; i++)
        {
            dist[dig][from][1][i] = abs(a[1][i] - dig);
            q.push({-abs(a[1][i] - dig), {1, i}});
        }

    else
        if (from == 1)
        for (int i = 1; i <= n; i++)
    {
        dist[dig][from][i][m] = abs(a[i][m] - dig);
        q.push({-abs(a[i][m] - dig), {i, m}});
    }


    else
        if (from == 2)
        for (int i = 1; i <= m; i++)
    {
        dist[dig][from][n][i] = abs(a[n][i] - dig);
        q.push({-abs(a[n][i] - dig), {n, i}});
    }

    else
        for (int i = 1; i <= n; i++)
    {
        dist[dig][from][i][1] = abs(a[i][1] - dig);
        q.push({-abs(a[i][1] - dig), {i, 1}});
    }

    while (!q.empty())
    {
        auto ver = q.top();
        q.pop();

        if (-ver.first != dist[dig][from][ver.second.first][ver.second.second])
            continue;

        for (auto i: adj[ver.second.first][ver.second.second])
        {
            int curr_cost = -ver.first + abs(a[i.first][i.second] - dig);
            if (curr_cost < dist[dig][from][i.first][i.second])
            {
                par[dig][from][i.first][i.second] = ver.second;
                dist[dig][from][i.first][i.second] = curr_cost;
                q.push({-curr_cost, {i.first, i.second}});
            }
        }
    }
}

vector <pair <int, int> > get_path(int dig, int from, int x, int y)
{
    vector <pair <int, int> > ans;
    while (x != -1)
    {
        ans.push_back({x, y});

        auto curr = par[dig][from][x][y];
        x = curr.first;
        y = curr.second;
    }

    return ans;
}

vector <pair <int, int> > v1, v2;
void solve()
{
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
    {
        if (i != 1)
        adj[i][j].push_back({i-1, j});

        if (i != n)
        adj[i][j].push_back({i+1, j});

        if (j != 1)
        adj[i][j].push_back({i, j-1});

        if (j != m)
        adj[i][j].push_back({i, j+1});
    }

    for (int i = 0; i <= 9; i++)
    for (int j = 0; j <= 3; j++)
        dijkstra(i, j);


}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
