#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int maxn = 1e6 + 3;
const int bucket = 503;

int n, m, t;
vector <int> adj[maxn];
pair <int, int> flight[maxn];
void read()
{
    cin >> n >> m >> t;
    for (int i = 1; i <= n; i++)
    {
        int k;
        cin >> k;

        for (int j = 1; j <= k; j++)
        {
            int to;
            cin >> to;
            to++;

            adj[i].push_back(to);
        }

        sort (adj[i].begin(), adj[i].end());
    }

    for (int i = 1; i <= t; i++)
    {
        cin >> flight[i].first >> flight[i].second;
        flight[i].first++;
        flight[i].second++;
    }
}

int dp[maxn], lazy[maxn];
bool is_big[maxn];
vector <int> big;

bool is_con(int a, int b)
{
    auto it = lower_bound(adj[a].begin(), adj[a].end(), b);
    if (it == adj[a].end() || *it != b)
        return false;

    return true;
}

int find_val(int idx)
{
    int ans = dp[idx];
    for (auto i: big)
    if (is_con(idx, i))
    ans = max(ans, lazy[i]);

    return ans;
}

void solve()
{

    for (int i = 1; i <= n; i++)
    if ((int)adj[i].size() > bucket)
    {
        is_big[i] = true;
        big.push_back(i);
    }

    for (int j = t; j >= 1; j--)
    {
        int val = find_val(flight[j].second) + 1;
        if (!is_big[flight[j].first])
        {
            for (auto i: adj[flight[j].first])
            dp[i] = max(dp[i], val);
            dp[flight[j].first] = max(dp[flight[j].first], val);
        }

        else
        {
            dp[flight[j].first] = max(dp[flight[j].first], val);
            lazy[flight[j].first] = max(lazy[flight[j].first], val);
        }
    }

    int ans = 0;
    for (int i = 1; i <= n; i++)
    {
        ans = max(ans, dp[i]);
        ans = max(ans, lazy[i]);
    }

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
