#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}
const ll mod = 1e9 + 7;

const ll MAX_N = 510;
ll tab[MAX_N][MAX_N];
ll dist[MAX_N * MAX_N], ans[MAX_N * MAX_N];
ll n, m;

ll encode(pair<ll, ll> a) {
    ll x = a.first;
    ll y = a.second;
    return x * m + y;
}

vector<ll> curr;
void bfs(ll c) {
    fill_n(dist, MAX_N * MAX_N, mod);
    priority_queue<pair<ll, ll> > pq;
    for(auto it : curr) {
        pq.push({0, it});
        dist[it] = 0;
    }
    curr.clear();
    //cout << n << " " << m << endl;
    while(!pq.empty()) {
        auto curr = pq.top(); pq.pop();
        pair<ll, ll> it = {curr.second / m, curr.second % m};
        curr.first -= abs(tab[it.first][it.second] - c);
        //cout << it.first << " " << it.second << " " << curr.first << endl;
        if(it.first > 0) {
            if(dist[curr.second - m] > -curr.first) {
                pq.push({curr.first, curr.second - m});
                dist[curr.second - m] = -curr.first;
            }
        }
        if(it.first < n - 1) {
            if(dist[curr.second + m] > -curr.first) {
                pq.push({curr.first, curr.second + m});
                dist[curr.second + m] = -curr.first;
            }
        }
        if(it.second > 0) {
            if(dist[curr.second - 1] > -curr.first) {
                pq.push({curr.first, curr.second - 1});
                dist[curr.second - 1] = -curr.first;
            }
        }
        if(it.second < m - 1) {
            //cout << curr.second + 1 << " " << curr.second << endl;
            if(dist[curr.second + 1] > -curr.first) {
                pq.push({curr.first, curr.second + 1});
                dist[curr.second + 1] = -curr.first;
            }
        }
    }

    for(ll i = 0; i < n * m; i ++) {
        ans[i] += dist[i];
    }
    return;
    cout << c << endl;
    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < m; j ++) {
            cout << dist[encode({i, j})] << " ";
        }
        cout << endl;
    }
}

signed main() {//
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> m;
    for(ll i = 0; i < n; i ++) {
        string in;
        cin >> in;
        for(ll j = 0; j < m; j ++) {
            tab[i][j] = in[j] - '0';
        }
    }
    ll ret = mod;
    for(ll c = 0; c < 10; c ++) {
        for(ll i = 0; i < n; i ++) {
            curr.push_back(encode({i, 0}));
        }
        bfs(c);
        for(ll i = 0; i < n; i ++) {
            curr.push_back(encode({i, m - 1}));
        }
        bfs(c);
        for(ll i = 0; i < m; i ++) {
            curr.push_back(encode({0, i}));
        }
        bfs(c);
        for(ll i = 0; i < m; i ++) {
            curr.push_back(encode({n - 1, i}));
        }
        bfs(c);
        for(ll i = 0; i < n * m; i ++) {
            if(chkmin(ret, ans[i] + abs(c - tab[i / m][i % m]))) {
                //cout << c << " " << i / m << " " << i % m << endl;
            }
            ans[i] = 0;
        }
        //cout << c << " " << ret << endl;
        //return 0;
    }
    cout << ret << endl;
    return 0;
}
