#include <bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) {return x < y ? x = y, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) {return x > y ? x = y, 1 : 0;}
const ll mod = 1e9 + 7;

const int MAX_N = 5e5 + 10;
vector<int> tree[MAX_N * 4];
int val[MAX_N], arr[MAX_N], pref[MAX_N];

void build(int curr, int l, int r) {
    if(l == r) {
        tree[curr] = {pref[l]};
        return;
    }
    int m = (l + r) / 2ll;
    build(curr * 2, l, m);
    build(curr * 2 + 1, m + 1, r);
    merge(tree[curr * 2].begin(), tree[curr * 2].end(), tree[curr * 2 + 1].begin(), tree[curr * 2 + 1].end(), back_inserter(tree[curr]));
}

int ans1(int curr, int l, int r, int ql, int qr, int small) {
    if(ql <= l && r <= qr) {
        return lower_bound(tree[curr].begin(), tree[curr].end(), small) - tree[curr].begin();
    } else if(l > qr || r < ql) {
        return 0;
    }
    int m = (l + r) / 2ll;
    return ans1(curr * 2, l, m, ql, qr, small) + ans1(curr * 2 + 1, m + 1, r, ql, qr, small);
}

int ans2(int curr, int l, int r, int ql, int qr, int big) {
    if(ql <= l && r <= qr) {
        return tree[curr].end() - upper_bound(tree[curr].begin(), tree[curr].end(), big);
        cout << l << " " << r << " " << ql << " " << qr << " " << big << endl;
        for(auto it : tree[curr]) {
            cout << it << " ";
        }
        cout << endl;
        cout << tree[curr].end() - upper_bound(tree[curr].begin(), tree[curr].end(), big) << endl;
        cout << endl;
    } else if(l > qr || r < ql) {
        return 0;
    }
    int m = (l + r) / 2ll;
    return ans2(curr * 2, l, m, ql, qr, big) + ans2(curr * 2 + 1, m + 1, r, ql, qr, big);
}

bool line = true;
vector<int> g[MAX_N];
int ret[MAX_N];
vector<int> ans[MAX_N];
vector<pair<int, int> > query[MAX_N];
int currsum = 0, nowans = 0;
void dfs(int x, int p) {
    currsum += arr[x];
    if(currsum > 0) {nowans ++;}
    for(auto it : ans[x]) {
        ret[it] = nowans;
    }
    for(auto it : g[x]) {
        if(it == p) {continue;}
        dfs(it, x);
    }
    if(currsum > 0) {nowans --;}
    currsum -= arr[x];
}

signed main() {//
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    int n, q;
    cin >> n >> q;
    string in;
    cin >> in;
    for(int i = 0; i < n; i ++) {
        if(in[i] == '+') {
            arr[i + 1] = 1;
        } else {
            arr[i + 1] = -1;
        }
    }
    for(int i = 0; i < n - 1; i ++) {
        int a, b;
        cin >> a >> b;
        if(a != i + 1 || b != i + 2) {line = false;}
        g[a].push_back(b);
        g[b].push_back(a);
    }
    if(line) {
        pref[0] = 0;
        for(int i = 1; i <= n; i ++) {
            pref[i] = arr[i] + pref[i - 1];
        }
        build(1, 0, n);
        while(q --) {
            int a, b;
            cin >> a >> b;
            if(a >= b) {
                cout << ans1(1, 0, n, b - 1, a - 1, pref[a]) << endl;
            } else {
                cout << ans2(1, 0, n, a, b, pref[a - 1]) << endl;
            }
        }
    } else {
        for(int i = 0; i < q; i ++) {
            int a, b;
            cin >> a >> b;
            query[a].push_back({b, i});
        }
        for(int i = 1; i <= n; i ++) {
            if(query[i].empty()) {continue;}
            for(auto it : query[i]) {
                ans[it.first].push_back(it.second);
            }
            dfs(i, 0);
            for(auto it : query[i]) {
                ans[it.first].pop_back();
            }
        }
        for(int i = 0; i < q; i ++) {
            cout << ret[i] << endl;
        }
    }
    return 0;
}

/*
6 4
+-++--
1 2
2 3
3 4
4 5
5 6
1 6
6 1
5 1
2 4
*/
