#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e2 + 5;

int n, m, t;
vector <int> graph[MAXN];
vector < pair<int, int> > grd[MAXN];

void read_input()
{
	cin >> n >> m >> t;

	int c, w;
	for(int i = 0; i < n; i++)
	{
		cin >> c;
		for(int j = 0; j < c; j++)
		{
			cin >> w;
			graph[i].push_back(w);
		}
	}
	int v;
	for(int i = 0; i < t; i++)
	{
		cin >> v >> w;
		grd[v].push_back({i, w});
	}
}

vector< pair<int, int> > pol[MAXN];

const int MAXT = 1e2 + 5;

int T[MAXN][MAXT];

int rec(int v, int tm)
{
	if(T[v][tm] != -1) return T[v][tm];
	if(tm == t)
	{
		return 0;
	}
	int ans = 0;
	for(auto x : pol[v])
	{
		if(x.first >= tm)
		{
			ans = max(ans, rec(x.second, x.first) + 1);
		}
	}
	ans = max(ans, rec(v, tm + 1));
	return T[v][tm] = ans;
}

void solve()
{
	for(int i = 0; i < n; i++)
	{
		for(auto z : grd[i])
		{
			pol[i].push_back({z.first, z.second});
		}
		for(auto x : graph[i])
		{
			for(auto z : grd[x])
			{
				pol[i].push_back({z.first, z.second});
			}
		}
		sort(pol[i].begin(), pol[i].end());
	}
	memset(T, -1, sizeof(T));
	int answer = 0;
	for(int i = 0; i < n; i++)
	{
		answer = max(answer, rec(i, 0));
	}
	cout << answer << "\n";
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	read_input();
	solve();

	return 0;
}
