#include <bits/stdc++.h>

using namespace std;

#define MAX 510000

int n, q, a, b, st[MAX], pr1[MAX], pr2[MAX], pr3[MAX], tr[MAX * 8], tr2[MAX * 8], res[MAX];

vector<int> gr[MAX];

struct point
{
    int x, y, v, idx;
}tmp;

vector<point> w, e;

void upd(int v, int l, int r, int q)
{
    if(l > q || r < q)return;
    if(l == r && l == q)
    {
        tr[v]++;
        return;
    }
    int mid = (l + r) / 2;
    upd(v * 2, l, mid, q);
    upd(v * 2 + 1, mid + 1, r, q);
    tr[v] = tr[v*2] + tr[v * 2 + 1];
    return;
}

int query(int v, int l, int r, int ql, int qr)
{
    if(l > qr || r < ql)return 0;
    if(l >= ql && r <= qr)return tr[v];
    int mid = (l + r) / 2;
    return query(v * 2, l, mid, ql, qr) + query(v * 2 + 1, mid + 1, r, ql, qr);
}

void upd2(int v, int l, int r, int q)
{
    if(l > q || r < q)return;
    if(l == r && l == q)
    {
        tr2[v]++;
        return;
    }
    int mid = (l + r) / 2;
    upd2(v * 2, l, mid, q);
    upd2(v * 2 + 1, mid + 1, r, q);
    tr2[v] = tr2[v*2] + tr2[v * 2 + 1];
    return;
}

int query2(int v, int l, int r, int ql, int qr)
{
    if(l > qr || r < ql)return 0;
    if(l >= ql && r <= qr)return tr2[v];
    int mid = (l + r) / 2;
    return query2(v * 2, l, mid, ql, qr) + query2(v * 2 + 1, mid + 1, r, ql, qr);
}

char c[MAX];

void dfs(int a, int b, int par, int s, int br)
{
    if(a == b)
    {
        printf("%d\n" , br);
        return;
    }
    for(int i = 0; i < gr[a].size(); i++)
    {

        if(gr[a][i] != par)
        {
            if(st[gr[a][i]] == 1)dfs(gr[a][i], b, a, s + 1, br + (s >= 0));
            else dfs(gr[a][i], b, a, s - 1, br + (s >= 2));
        }
    }
    return ;
}

void brute()
{

    for(int i = 0; i < q; i++)
    {
        scanf("%d%d", &a, & b);
        if(st[a] == 1)dfs(a, b, -1, st[a], 1);
        else dfs(a, b, -1, -1, 0);
    }
}

bool cmp(point a, point b)
{
    if(a.x > b.x)return 0;
    if(a.x < b.x)return 1;
    if(a.v <= b.v)return 0;
    return 1;
}

int main()
{
    scanf("%d%d", &n, &q);
    cin >> c;
    for(int i = 0; i < n; i++)if(c[i] == '+')st[i + 1] = 1;
    else st[i + 1] = -1;
    for(int i = 0; i < n - 1; i++)
    {
        scanf("%d%d", &a, &b);
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    pr1[0] = pr3[n + 1] = n + 1;
    for(int i = 1; i <= n; i++)pr1[i] = pr1[i - 1] + st[i];
    for(int i = n; i >= 1; i--)pr3[i] = pr3[i + 1] + st[i];


    pr1[0] = pr3[n + 1] = pr3[n + 1]= n + 1;
    for(int i = 0; i <= n; i++)pr2[i] = pr3[ n - i + 1];
    if(n < 10000)
    {
        brute();
        return 0;
    }
    for(int i = 0; i < q; i++)
    {
        scanf("%d%d",&a, &b);
        if(a <= b)
        {
            tmp = {a-1 , pr1[a - 1], -1, i};
            w.push_back(tmp);
            tmp = {b , pr1[a - 1] , 1, i};
            w.push_back(tmp);
            tmp = {a-1 , 2 * n + 1, 1, i};
            w.push_back(tmp);
            tmp = {b, 2 * n + 1, -1, i};
            w.push_back(tmp);
        }
        else
        {
            a = (n - a + 1);
            b = (n - b + 1);
            tmp = {a-1 , pr2[a - 1], -1, i};
            e.push_back(tmp);
            tmp = {b , pr2[a - 1] , 1, i};
            e.push_back(tmp);
            tmp = {a-1 , 2 * n + 1, 1, i};
            e.push_back(tmp);
            tmp = {b, 2 * n + 1, -1, i};
            e.push_back(tmp);
        }
    }
    for(int i = 1; i <= n; i++)
    {
        tmp = {i, pr1[i], 2, 0};
        w.push_back(tmp);
        tmp = {i, pr2[i], 2, 0};
        e.push_back(tmp);
    }
    sort(w.begin(), w.end(), cmp);
    //for(int i = 0; i < w.size(); i++)cout << w[i].x << "  " << w[i].y << " " << w[i].v << endl;
    sort(e.begin(), e.end(), cmp);
    for(int i = 0; i  < w.size(); i++)
    {

        if(w[i].v == -1)
        {
            res[w[i].idx] += query2(1, 1, 2 * n + 1, 1, w[i].y);
        }
        else if(w[i].v == 1)
        {
            res[w[i].idx] -= query2(1, 1, 2* n + 1, 1, w[i].y);
        }
        else
        {
            upd2(1, 1, 2 * n + 1, w[i].y);
        }
    }
    for(int i = 0; i  < e.size(); i++)
    {

        if(e[i].v == -1)
        {
            res[e[i].idx] += query(1, 1, 2 * n + 1, 1, e[i].y);
        }
        else if(e[i].v == 1)
        {
            res[e[i].idx] -= query(1, 1, 2* n + 1, 1, e[i].y);
        }
        else
        {
            upd(1, 1, 2 * n + 1, e[i].y);
        }
    }
    for(int i = 0; i < q; i++)cout << res[i] << endl;
    return 0;
}
