#include <bits/stdc++.h>
using namespace std;
int n, m, a [512][512], ans = 1000000000;
vector <pair <int, int> > adj [300005];
vector <int> dijkstra (int u){
    vector <int> dist (n * m + 4);
    bool used [n * m + 4] = {0};
    priority_queue <pair <int, int> > pq;
    pq.push ({0, u});
    while (!pq.empty ()){
        auto p = pq.top ();
        pq.pop ();
        if (used [p.second]) continue;
        used [p.second] = 1;
        dist [p.second] = -p.first;
        for (auto e : adj [p.second]){
            if (!used [e.first]){
                pq.push ({-dist [p.second] - e.second, e.first});
            }
        }
    }
    return dist;
}
int main (){
/*
	ios::sync_with_stdio (false);
	cin.tie (0);*/

	cin >> n >> m;
	for (int i = 0; i < n; i ++){
        string str;
        cin >> str;
        for (int j = 0; j < m; j ++){
            a [i][j] = str [j] - '0';
        }
	}
	for (int I = 0; I < 10; I ++){
        for (int i = 0; i <= 300005; i ++) adj [i].clear ();
        for (int i = 1; i < m; i ++){
            int u = i, v = i - 1;
            adj [u].push_back ({v, abs (a [0][i - 1] - I)});
            adj [v].push_back ({u, abs (a [0][i] - I)});
        }
        for (int i = 1; i < n; i ++){
            int u = i * m, v = (i - 1) * m;
            adj [u].push_back ({v, abs (a [i - 1][0] - I)});
            adj [v].push_back ({u, abs (a [i][0] - I)});
            for (int j = 1; j < m; j ++){
                int u = i * m + j, v = (i - 1) * m + j;
                adj [u].push_back ({v, abs (a [i - 1][j] - I)});
                adj [v].push_back ({u, abs (a [i][j] - I)});
                v = i * m + j - 1;
                adj [u].push_back ({v, abs (a [i][j - 1] - I)});
                adj [v].push_back ({u, abs (a [i][j] - I)});
            }
        }
        int u = n * m, d = u + 1, l = d + 1, r = l + 1;
        for (int i = 0; i < n; i ++){
            adj [l].push_back ({i * m, abs (a [i][0] - I)});
            adj [r].push_back ({(i + 1) * m - 1, abs (a [i][m - 1] - I)});
        }
        for (int i = 0; i < m; i ++){
            adj [u].push_back ({i, abs (a [0][i] - I)});
            adj [d].push_back ({(n - 1) * m + i, abs (a [n - 1][i] - I)});
        }
        vector <int> dist_u = dijkstra (u);
        vector <int> dist_d = dijkstra (d);
        vector <int> dist_l = dijkstra (l);
        vector <int> dist_r = dijkstra (r);
        for (int i = 0; i < n * m; i ++){
            ans = min (ans, dist_u [i] + dist_d [i] + dist_l [i] + dist_r [i] - 3 * abs (a [i / m][i % m] - I));
        }
	}
	cout << ans << '\n';

}
