#include <bits/stdc++.h>
#pragma GCC optimize ("O3")
using namespace std;
int n, m, a [512][512], ans = 1000000000;
vector <pair <int, int> > adj [300005];
bool used [300005];
vector <int> dist [300005];
priority_queue <pair <int, int> > pq;
void dijkstra (int u){
    dist [u].resize (n * m + 4);
    if (u < n * m + 4) pq.push ({0, u});
    while (!pq.empty ()){
        auto p = pq.top ();
        pq.pop ();
        if (used [p.second]) continue;
        used [p.second] = 1;
        dist [u][p.second] = -p.first;
        for (auto e : adj [p.second]){
            if (!used [e.first]){
                pq.push ({-dist [u][p.second] - e.second, e.first});
            }
        }
    }
}
int main (){

	ios::sync_with_stdio (false);
	cin.tie (0);

	cin >> n >> m;
	for (int i = 0; i < n; i ++){
        string str;
        cin >> str;
        for (int j = 0; j < m; j ++){
            a [i][j] = str [j] - '0';
        }
	}
	for (int I = 0; I < 10; I ++){
        for (int i = 0; i <= 300002; i ++) adj [i].clear ();
        for (int i = 1; i < m; i ++){
            int u = i, v = i - 1;
            adj [u].push_back ({v, abs (a [0][i - 1] - I)});
            adj [v].push_back ({u, abs (a [0][i] - I)});
        }
        for (int i = 1; i < n; i ++){
            int u = i * m, v = (i - 1) * m;
            adj [u].push_back ({v, abs (a [i - 1][0] - I)});
            adj [v].push_back ({u, abs (a [i][0] - I)});
            for (int j = 1; j < m; j ++){
                int u = i * m + j, v = (i - 1) * m + j;
                adj [u].push_back ({v, abs (a [i - 1][j] - I)});
                adj [v].push_back ({u, abs (a [i][j] - I)});
                v = i * m + j - 1;
                adj [u].push_back ({v, abs (a [i][j - 1] - I)});
                adj [v].push_back ({u, abs (a [i][j] - I)});
            }
        }
        int u = n * m, d = u + 1, l = d + 1, r = l + 1;
        for (int i = 0; i < n; i ++){
            adj [l].push_back ({i * m, abs (a [i][0] - I)});
            //adj [i * m].push_back ({l, 0});
            adj [r].push_back ({(i + 1) * m - 1, abs (a [i][m - 1] - I)});
            //adj [(i + 1) * m - 1].push_back ({r, 0});
        }
        for (int i = 0; i < m; i ++){
            adj [u].push_back ({i, abs (a [0][i] - I)});
            //adj [i].push_back ({u, 0});
            adj [d].push_back ({(n - 1) * m + i, abs (a [n - 1][i] - I)});
            //adj [(n - 1) * m + i].push_back ({d, 0});
        }
        for (int i = n * m; i < n * m + 4; i ++){
            dijkstra (i);
            for (int j = 0; j < n * m + 4; j ++) used [j] = 0;
        }
        for (int i = 0; i < n * m; i ++) pq.push ({-dist [u][i] - dist [r][i] + abs (a [i / m][i % m] - I), i});
        dijkstra (n * m + 5);
        for (int j = 0; j < n * m + 4; j ++) used [j] = 0;
        for (int i = 0; i < n * m; i ++) pq.push ({-dist [u][i] - dist [l][i] + abs (a [i / m][i % m] - I), i});
        dijkstra (n * m + 6);
        for (int j = 0; j < n * m + 4; j ++) used [j] = 0;
        for (int i = 0; i < n * m; i ++) pq.push ({-dist [d][i] - dist [r][i] + abs (a [i / m][i % m] - I), i});
        dijkstra (n * m + 7);
        for (int j = 0; j < n * m + 4; j ++) used [j] = 0;
        for (int i = 0; i < n * m; i ++) pq.push ({-dist [d][i] - dist [l][i] + abs (a [i / m][i % m] - I), i});
        dijkstra (n * m + 8);
        for (int j = 0; j < n * m + 4; j ++) used [j] = 0;
        for (int i = 0; i < n * m; i ++){/*
            for (int j = 0; j < n * m; j ++){
                ans = min (ans, dist [i][u] + dist [i][r] + dist [j][d] + dist [j][l] + dist [j][i] + abs (a [j / m][j % m] - I));
                ans = min (ans, dist [i][u] + dist [i][l] + dist [j][d] + dist [j][r] + dist [j][i] + abs (a [j / m][j % m] - I));
            }*/
            ans = min (ans, dist [n * m + 5][i] + dist [n * m + 8][i] - abs (a [i / m][i % m] - I));
            ans = min (ans, dist [n * m + 6][i] + dist [n * m + 7][i] - abs (a [i / m][i % m] - I));
        }
	}
	cout << ans << '\n';

}
