
#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x <<endl

using namespace std;

void set_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, m, t;
vector<vector<int>> adj_list;
vector<pair<int, int>> flights;

void read() {
    cin >> n >> m >> t;

    adj_list.resize(n);
    for (int i = 0; i < n; i++) {
        int cnt;
        cin >> cnt;

        for (int j = 0; j < cnt; j++) {
            int to;
            cin >> to;

            adj_list[i].emplace_back(to);
        }
    }

    flights.resize(t);
    for (auto &flight : flights) {
        cin >> flight.first >> flight.second;
    }
}

vector<int> dp;

int main() {
    set_io();

    read();

    dp.resize(n, 0);

    int best = 1;

    dp[flights[0].second] = 1;

    for (int i = 1; i < t; i++) {
        int max_value = dp[flights[i].first];
        for (int adj_node : adj_list[flights[i].first]) {
            max_value = max(max_value, dp[adj_node]);
        }

        dp[flights[i].second] = max(dp[flights[i].second], max_value + 1);
        best = max(best, dp[flights[i].second]);
    }

    cout << best << endl;

    return EXIT_SUCCESS;
}
