#include <iostream>
#include <vector>
#include <string>
using namespace std;

const int MAXN = 500005;

int n, q;
vector<int> g[MAXN];
string s;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> q;
    cin >> s;
    s = "0" + s;
    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}

void DFS(int u, int t, int p, int res, int tmp)
{
    if (s[u] == '+') tmp++;
    else tmp--;
    if (tmp > 0) res++;

    if (u == t)
    {
        cout << res << endl;
        return;
    }

    for (int v : g[u])
    {
        if (v != p) DFS(v, t, u, res, tmp);
    }
}

int main()
{
    Init();

    for (int i = 1; i <= q; ++ i)
    {
        int a, b;
        cin >> a >> b;
        DFS(a, b, 0, 0, 0);
    }
}
