#include <iostream>
#include <vector>
#include <utility>
#define fi first
#define se second
using namespace std;

const int MAXN = 500005;

int n, m, t;
vector<int> g[MAXN];
vector<pair<int, int>> f;

int dp[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> t;
    for (int i = 0; i < n; ++ i)
    {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++ j)
        {
            int x;
            cin >> x;
            g[i].push_back(x);
        }
    }
    for (int i = 0; i < t; ++ i)
    {
        int u, v;
        cin >> u >> v;
        f.emplace_back(u, v);
    }
}

int main()
{
    Init();

    for (int i = t - 1; i >= 0; -- i)
    {
        int s = f[i].fi, t = f[i].se;
        dp[s] = max(dp[s], dp[t] + 1);
        for (int j = 0; j < g[s].size(); ++ j)
        {
            dp[g[s][j]] = max(dp[g[s][j]], dp[t] + 1);
        }
    }

    int opt = 0;
    for (int i = 0; i < n; ++ i)
    {
        opt = max(opt, dp[i]);
    }

    cout << opt << endl;
    return 0;
}
